# oss-session-manager
A NPM package/module to create sessions and log users in for the OSS project

<h1>Disclaimer: </h1>
This method isn't very secure, because the tokens are pseudo-random generated... JavaScript isn't random because it can't use the hardware for random values.

<h2>Usage: </h2>
You've to require the package in your NodeJS file:

```javascript
const session = require("oss-session-manager");
```
<h3>Initialize: </h3>
And you have to call the initialize function. 

```javascript
{"tokenLength":16,"expires":86400000,"database":{"type":"File System","fileSystem":{"path":"./sessions/"}}}
```

And you have to call the initialize function.

```javascript
session.init();
```


<h3>Create a session: </h3>
To create a session, you can use the createSession function.
This function needs two parameters.
<li>Username: The username of the user where the session belongs to. </li>
<li>IP: The ip of the user where the session belongs to. </li>

```javascript
session.createSession("J0eppp", "1.1.1.1");
```

If everything is set up correctly, you should get "J0eppp.json" with the following data:
```JSON
{"username":"J0eppp","sessionToken":"dgAHQh5G006dXg13","ip":"1.1.1.1"}
```
(The sessionToken looks different ofcourse)


<h3>Verify a session: </h3>
To verify a session, you can use the verifySession function.
This function needs three parameters.
<li>Username</li>
<li>Cookies: All the cookies you got from the client</li>
<li>IP-address</li>

```javascript
session.verifySession(username, cookies, ip);
```

This'll return:
```javascript
[ true ]
````
or:
```javascript
[ false, "No session" ]
```

or:
```javascript
[ false, "sessionToken or ip isn't the same!" ]
```

or:
```javascript
[ false, "No session token is found!" ]
```

<h3>Example: </h3>
You can use "run.js" to test it..
