const fs = require('fs');
const createSession = require('./createSession');
const verifySession = require('./verifySession');
const login = require('./login');
const loginWithSession = require("./loginWithSession");

// fs.writeFileSync("./options.json", "{}");

var options;

var mariadb;
var mysql;

function init(options) {
  options = JSON.parse(fs.readFileSync("./options.json"));
  if (options.database.type === undefined) {
    console.log("Please set the database type, you can choose between: MongoDB");
    process.exit();
  } else {
    switch (options.database.type) {
      case "MySQL":
        // MySQL is set as database
        if (options.database.mySQL.host === undefined) {
          console.log("The MySQL host is undefined, please define it. (location: options.database.mySQL.host)");
          process.exit()
        } if (options.database.mySQL.database === undefined) {
          console.log("The MySQL database is undefined, please define it. (location: options.database.mySQL.database)");
          process.exit();
        } if (options.database.mySQL.table === undefined) {
          console.log("The MySQL database table is undefined, please define it. (location: options.database.mySQL.table)");
          process.exit();
        }
        mysql = require("./mysql");
        mysql.connect(options.database.mySQL.host, options.database.mySQL.username, options.database.mySQL.password, options.database.mySQL.database, options.database.mySQL.table);
        break;
      case "File System" || "fileSystem" || "fs":
        var path = options.database.fileSystem.path;
        break;
      case "MongoDB":
        // MongoDB is set as database
        console.log("MongoDB");
        break;
      default:
        console.log("The database type '" + options.database.type + "' isn't supported!");
    }
  }
}

module.exports = {
  createSession: createSession,
  init: init,
  verifySession: verifySession,
  login: login,
  loginWithSession: loginWithSession,
  options: options
};
