const saveSession = require('./saveSession');
const fs = require('fs');
const getOptions = require('./getOptions');

const options = getOptions();

function createToken() {
  var length = options.tokenLength;
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  for (var i = 0; i < length; i++)
    text += possible.charAt(Math.floor(Math.random() * possible.length));

  return text;
}

function createSession(username, ip) {
  var token = createToken(options.tokenLength);
  var expires = Date.now() + options.expires;
  var sessionInfo = {
    username: username,
    sessionToken: token,
    ip: ip,
    expires: expires
  }
  saveSession(sessionInfo);
  return sessionInfo;
}

module.exports = createSession;
