const fs = require('fs');
const login = require('./login');

var cookie = "profilesNewSession=lol123;session=dasdlfasfd;";

function getCookie(name, cookies) {
  var regexp = new RegExp("(?:^" + name + "|;\s*"+ name + ")=(.*?)(?:;|$)", "g");
  var result = regexp.exec(cookies);
  return (result === null) ? null : result[1];
}

var options = JSON.parse(fs.readFileSync("./options.json").toString());

function verifySession(username, cookies, ip) {
  switch (options.database.type) {
    case "File System":
      if (!fs.existsSync(options.database.fileSystem.path + getCookie("sessionToken", cookies) + ".json")) {
        return [false, "No session"];
      } else {
        var session = JSON.parse(fs.readFileSync(options.database.fileSystem.path + getCookie("sessionToken", cookies) + ".json").toString());
        var sessionToken = getCookie("sessionToken", cookies);
        if (sessionToken === null) {
          return [false, "No session token is found!"];
        } else {
          if (sessionToken === session.sessionToken && ip === session.ip) {
            if (session.expires > Date.now()) {
              // Session is valid
              return [true];
            } else {
              return [false, "Session expired"];
            }
          } else {
            return [false, "sessionToken or ip isn't the same!"];
          }
        }
      }
      break;
    default:
      return "Error";
  }
}

module.exports = verifySession;
